what4-1.6.3: Solver-agnostic symbolic values support for issuing queries

Copyright | (c) Galois Inc 2015-2020
License | BSD3
Maintainer | Joe Hendrix <rdockins@galois.com>
Stability | provisional
Safe Haskell | None
Language | Haskell2010

What4.Solver.STP

Description

STP-specific tweaks to the basic SMTLib2 solver interface.

Synopsis

- data STP = STP
- stpAdapter :: forall (st :: Type -> Type). SolverAdapter st
- stpPath :: ConfigOption (BaseStringType Unicode)
- stpTimeout :: ConfigOption BaseIntegerType
- stpOptions :: [ConfigDesc]
- stpFeatures :: ProblemFeatures
- runSTPInOverride :: forall t (st :: Type -> Type) fs a. ExprBuilder t st fs -> LogData -> [BoolExpr t] -> (SatResult (GroundEvalFn t, Maybe (ExprRangeBindings t)) () -> IO a) -> IO a
- withSTP :: forall t (st :: Type -> Type) fs a. ExprBuilder t st fs -> FilePath -> LogData -> (Session t STP -> IO a) -> IO a

# Documentation

data STP Source #

Constructors

STP |

#### Instances

Instances details

Show STP Source # |
Instance details Defined in What4.Solver.STP Methods showsPrec :: Int -> STP -> ShowS Source # show :: STP -> String Source # showList :: [STP] -> ShowS Source #
SMTLib2GenericSolver STP Source # |

Instance details

Defined in What4.Solver.STP

Methods

defaultSolverPath :: forall t (st :: Type -> Type) fs. STP -> ExprBuilder t st fs -> IO FilePath Source #

defaultSolverArgs :: forall t (st :: Type -> Type) fs. STP -> ExprBuilder t st fs -> IO [String] Source #

defaultFeatures :: STP -> ProblemFeatures Source #

getErrorBehavior :: STP -> WriterConn t (Writer STP) -> IO ErrorBehavior Source #

supportsResetAssertions :: STP -> Bool Source #

setDefaultLogicAndOptions :: WriterConn t (Writer STP) -> IO () Source #

newDefaultWriter :: forall t (st :: Type -> Type) fs. STP -> AcknowledgementAction t (Writer STP) -> ProblemFeatures -> Maybe (ConfigOption BaseBoolType) -> ExprBuilder t st fs -> OutputStream Text -> InputStream Text -> IO (WriterConn t (Writer STP)) Source #

withSolver :: forall t (st :: Type -> Type) fs b. STP -> AcknowledgementAction t (Writer STP) -> ProblemFeatures -> Maybe (ConfigOption BaseBoolType) -> ExprBuilder t st fs -> FilePath -> LogData -> (Session t STP -> IO b) -> IO b Source #

runSolverInOverride :: forall t (st :: Type -> Type) fs b. STP -> AcknowledgementAction t (Writer STP) -> ProblemFeatures -> Maybe (ConfigOption BaseBoolType) -> ExprBuilder t st fs -> LogData -> [BoolExpr t] -> (SatResult (GroundEvalFn t, Maybe (ExprRangeBindings t)) () -> IO b) -> IO b Source #

SMTLib2Tweaks STP Source # |

Instance details

Defined in What4.Solver.STP

Methods

smtlib2tweaks :: STP Source #

smtlib2exitCommand :: Maybe Command Source #

smtlib2arrayType :: [Sort] -> Sort -> Sort Source #

smtlib2arrayConstant :: Maybe ([Sort] -> Sort -> Term -> Term) Source #

smtlib2arraySelect :: Term -> [Term] -> Term Source #

smtlib2arrayUpdate :: Term -> [Term] -> Term -> Term Source #

smtlib2StringSort :: Sort Source #

smtlib2StringTerm :: Text -> Term Source #

smtlib2StringLength :: Term -> Term Source #

smtlib2StringAppend :: [Term] -> Term Source #

smtlib2StringContains :: Term -> Term -> Term Source #

smtlib2StringIndexOf :: Term -> Term -> Term -> Term Source #

smtlib2StringIsPrefixOf :: Term -> Term -> Term Source #

smtlib2StringIsSuffixOf :: Term -> Term -> Term Source #

smtlib2StringSubstring :: Term -> Term -> Term -> Term Source #

smtlib2StructSort :: [Sort] -> Sort Source #

smtlib2StructCtor :: [Term] -> Term Source #

smtlib2StructProj :: Int -> Int -> Term -> Term Source #

smtlib2declareStructCmd :: Int -> Maybe Command Source #

OnlineSolver (Writer STP) Source # |
Instance details Defined in What4.Solver.STP Methods startSolverProcess :: forall scope (st :: Type -> Type) fs. ProblemFeatures -> Maybe Handle -> ExprBuilder scope st fs -> IO (SolverProcess scope (Writer STP)) Source # shutdownSolverProcess :: SolverProcess scope (Writer STP) -> IO (ExitCode, Text) Source #

stpAdapter :: forall (st :: Type -> Type). SolverAdapter st Source #

stpPath :: ConfigOption (BaseStringType Unicode) Source #

Path to stp

stpTimeout :: ConfigOption BaseIntegerType Source #

Per-check timeout, in milliseconds (zero is none)

stpOptions :: [ConfigDesc] Source #

stpFeatures :: ProblemFeatures Source #

runSTPInOverride :: forall t (st :: Type -> Type) fs a. ExprBuilder t st fs -> LogData -> [BoolExpr t] -> (SatResult (GroundEvalFn t, Maybe (ExprRangeBindings t)) () -> IO a) -> IO a Source #

withSTP Source #

Arguments

:: forall t (st :: Type -> Type) fs a. ExprBuilder t st fs |
-> FilePath | Path to STP executable
-> LogData |
-> (Session t STP -> IO a) | Action to run
-> IO a |

Run STP in a session. STP will be configured to produce models, buth otherwise left with the default configuration.